package xyz.lychee.lagfixer.libs.adventure.text.event;

import xyz.lychee.lagfixer.libs.adventure.audience.Audience;
import xyz.lychee.lagfixer.libs.adventure.permission.PermissionChecker;
import xyz.lychee.lagfixer.libs.adventure.util.Services;
import xyz.lychee.lagfixer.libs.adventure.util.TriState;
import xyz.lychee.lagfixer.libs.annotations.NotNull;

final class ClickCallbackInternals {
   static final PermissionChecker ALWAYS_FALSE;
   static final ClickCallback.Provider PROVIDER;

   private ClickCallbackInternals() {
   }

   static {
      ALWAYS_FALSE = PermissionChecker.always(TriState.FALSE);
      PROVIDER = (ClickCallback.Provider)Services.service(ClickCallback.Provider.class).orElseGet(Fallback::new);
   }

   static final class Fallback implements ClickCallback.Provider {
      public @NotNull ClickEvent create(final @NotNull ClickCallback<Audience> callback, final ClickCallback.@NotNull Options options) {
         return ClickEvent.suggestCommand("Callbacks are not supported on this platform!");
      }
   }
}
